﻿using System;
using System.Drawing;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace IPSToolLibrary
{

    public class MouseUtils
    {
        private int positionX;
        private int positionY;
        private int mouseIdleSince;
        private Timer timer;

        [DllImport("user32.dll")]
        private static extern Int32 ShowCursor(bool show);

        public MouseUtils()
        {
            positionX = 0;
            positionY = 0;
            mouseIdleSince = 0;

            timer = new Timer();
            timer.Interval = 1000;
            this.timer.Tick += new EventHandler(CalcMouseIdleSince);
            timer.Enabled = true;
        }


        public void CalcMouseIdleSince(object sender, EventArgs e)
        {
            Console.WriteLine("{0} Execute Timer, MouseIdleSince={1} ...",
                DateTime.Now.ToString("h:mm:ss.fff"), mouseIdleSince);

            mouseIdleSince++;
            if (positionX != Cursor.Position.X || positionY != Cursor.Position.Y)
            {
                mouseIdleSince = 0;
            }
            positionX = Cursor.Position.X;
            positionY = Cursor.Position.Y;
        }

        public static Point GetMousePosition()
        {
            return Cursor.Position;
        }

        public int GetMouseIdleSince()
        {
            return mouseIdleSince;
        }
    }
}
